### Method

# Gio File make_directory_with_parents

since: 2.18

#### Declaration [src]

    gboolean
    g_file_make_directory_with_parents (
      GFile* file,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Creates a directory and any parent directories that may not exist similar to ‘mkdir -p’. If the file system does not support creating directories, this function will fail, setting `error` to `G_IO_ERROR_NOT_SUPPORTED`. If the directory itself already exists, this function will fail setting `error` to `G_IO_ERROR_EXISTS`, unlike the similar g_mkdir_with_parents().

For a local `GFile` the newly created directories will have the default (current) ownership and permissions of the current process.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

Available since: 2.18

#### Parameters

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if all directories have been successfully created, `FALSE` otherwise.